'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.fetchTerms = undefined;

var _effects = require('redux-saga/effects');

var effects = _interopRequireWildcard(_effects);

var _lodash = require('lodash.merge');

var _lodash2 = _interopRequireDefault(_lodash);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var _marked = [fetchResource].map(regeneratorRuntime.mark);

var REQUEST_TERMS = 'kasia/terms/REQUEST_TERMS';
var RECEIVE_DATA = 'kasia/terms/RECEIVE_DATA';

exports.default = kasiaPluginWpApiAllTerms;
var fetchTerms = exports.fetchTerms = function fetchTerms() {
  return { type: REQUEST_TERMS };
};

function fetch(WP, action) {
  switch (action.type) {
    case REQUEST_TERMS:
      return WP.allTerms().get();
    default:
      throw new Error('Unknown request type "' + action.request + '".');
  }
}

function fetchResource(WP, action) {
  var id, type, data;
  return regeneratorRuntime.wrap(function fetchResource$(_context) {
    while (1) {
      switch (_context.prev = _context.next) {
        case 0:
          id = action.id, type = action.type;
          _context.next = 3;
          return effects.call(fetch, WP, action);

        case 3:
          data = _context.sent;
          _context.next = 6;
          return effects.put({ type: RECEIVE_DATA, request: type, data: data, id: id });

        case 6:
        case 'end':
          return _context.stop();
      }
    }
  }, _marked[0], this);
}

function kasiaPluginWpApiAllTerms(WP, config) {
  WP.allTerms = WP.registerRoute(config.route || 'wp/v2', 'all-terms');

  return {
    reducers: _defineProperty({}, RECEIVE_DATA, function (state, action) {
      return (0, _lodash2.default)({}, state, { terms: action.data });
    }),
    sagas: [regeneratorRuntime.mark(function fetchTermsSaga() {
      var action;
      return regeneratorRuntime.wrap(function fetchTermsSaga$(_context2) {
        while (1) {
          switch (_context2.prev = _context2.next) {
            case 0:
              if (!true) {
                _context2.next = 8;
                break;
              }

              _context2.next = 3;
              return effects.take(function (action) {
                return action === REQUEST_TERMS;
              });

            case 3:
              action = _context2.sent;
              _context2.next = 6;
              return fetchResource(WP, action);

            case 6:
              _context2.next = 0;
              break;

            case 8:
            case 'end':
              return _context2.stop();
          }
        }
      }, fetchTermsSaga, this);
    })]
  };
}

kasiaPluginWpApiAllTerms.preload = function (WP) {
  return regeneratorRuntime.mark(function _callee() {
    return regeneratorRuntime.wrap(function _callee$(_context3) {
      while (1) {
        switch (_context3.prev = _context3.next) {
          case 0:
            return _context3.delegateYield(fetchResource(WP, fetchTerms()), 't0', 1);

          case 1:
          case 'end':
            return _context3.stop();
        }
      }
    }, _callee, this);
  });
};